//Ultrasound Game
import processing.sound.*;
//sound file

SoundFile file;
SoundFile pSound;
SoundFile endSound;
SoundFile impactSound;
SoundFile bonusSound;
String audio="EvilMortyExtended.mp3";
String path;
//pick sound
String pickPath;
String pickSound="portalsound.mp3";

//Screen sound
String startAudio="startmusic.mp3";
String winMusic="winmusic.mp3";
String endPath;
String endMusic="endmusic.mp3";

//Impact sound
String impactPath;
String impactMusic="impact.mp3";

//bonus sound
String bonusPath;
String bonusMusic="doublepoints.mp3";

//Mode for the screen
int mode=0;

int i, j; 

//Game live and score
int Score ;
int Live=50;

//Game items
float DistancePlaneBird;
float DistancePlaneDead;
float DistancePlaneFloor;
float DistancePlaneBonus;

//Plane controls
float Hauteur; //en Y
float Angle;
int DistanceUltra;
int IncomingDistance;


//Game items axis
float ItemX;
float ItemY;
float DeadX;
float DeadY;
float BonusX;
float BonusY;

//shoot
boolean fire=false;

int getRandomX(){
 return int(random(600)); 
}


int ballSize = 20;
int[] ballY = {getRandomX(), getRandomX(), getRandomX(), getRandomX(), getRandomX()};
int[] ballX= {500,500,500,500,500};


float FloorX ;  //for X position




String DataIn; //incoming data on the serial port

//5 a 32 cm


float [] CloudX = new float[6];
float [] CloudY = new float[6];
//float [] DeadX = new float[6];
//float [] DeadY = new float[6];

int startCounter=0;;

//Game images
PImage Cloud;
PImage Item;
PImage Dead;
PImage Plane;
PImage Floor;
PImage Bonus;

//Screen images
PImage startScreen;
PImage endScreen;
PImage winScreen;


// serial port config
import processing.serial.*; 
Serial myPort;    



//preparation
void setup() 
{
    
    myPort = new Serial(this, Serial.list()[0], 9600); 

    myPort.bufferUntil(10);   //end the reception as it detects a carriage return

    frameRate(30); 

    size(800, 600);
    rectMode(CORNERS) ; //we give the corners coordinates 
    noCursor(); //why not ?
    textSize(16);

    Hauteur = 300; //initial plane value


    Cloud = loadImage("cloud.png");  //load a picture
    Item = loadImage("pgun.png");  
    Dead = loadImage("Meteorite.png");
    Plane = loadImage("plane.png");  //the new plane picture
    Bonus = loadImage("bonus.png");
    Floor = loadImage("grass.jpg");  //some grass


    //int clouds position
    for  (int i = 1; i <= 3; i = i+1) {
        CloudX[i]=random(1000);
        CloudY[i]=random(700);
    }


    Score = 0;
}
    

//incoming data event on the serial port

void serialEvent(Serial p) { 
    DataIn = p.readString(); 
    // println(DataIn);

    IncomingDistance = int(trim(DataIn)); //conversion from string to integer

    println(IncomingDistance); //checks....

    if (IncomingDistance>1  && IncomingDistance<100 ) {
        DistanceUltra = IncomingDistance; //save the value only if its in the range 1 to 100     }
    }
}


//main drawing loop
void draw() 
{
    
    if(mode==0){
     if(startCounter==0){
       startCounter=-1;
       startScreenMusic();  
   }
       startScreen(); 
     
    }
    else
        if(mode==-1){
          Score=0;
          mode=-3;
          startWinMusic();
          winScreen();
        }
     else
         if(mode==-2){
           Score=0;
           Live=3;
           mode=-4;
           endScreen();
           endScreenMusic();
         }
   else
       if(mode==1){
    startCounter++;
    background(0, 0, 0);
    Ciel(); //draw the sky
    fill(5, 72, 0);



    //new ground : 

    for  (int i = -2; i <= 4; i = i+1) {  //a loop to display the grass picture 6 times

        image(Floor, 224*i  + FloorX, 550, 224, 58);  // 224 58 : picture size
    }

    //calculates the X grass translation. Same formulae than the bird
    FloorX = FloorX  -  cos(radians(Angle))*10;

    if (FloorX < -224) {  //why 224 ? to have a perfect loop
        FloorX=224;
    }


    //text(Angle, 10, 30); //debug things...
    //text(Hauteur, 10, 60); 
    
    
    //shoot
    
    //triangle(0,mouseY-8,30, mouseY+8,0, mouseY);
    if(fire){
     cannon(mouseY);
     fire=false;
    }
    ballFalling();

    // check the distance between the plane and object and increase the score
    DistancePlaneBird = sqrt(pow((400-ItemX), 2) + pow((Hauteur-ItemY), 2)) ;
    DistancePlaneDead = sqrt(pow((400-DeadX),2) + pow((Hauteur-DeadY),2));
    DistancePlaneBonus = sqrt(pow((400-BonusX),2) + pow((Hauteur-BonusY),2));

    //Plane hit score
    if (DistancePlaneBird < 40) {  
        Score = Score+ 1;

        //reset the bird position
        ItemX = 900;
        ItemY = random(600);
        pickMusic();     
    }
    
    //Plane hit meteorite
    if(DistancePlaneDead < 40){
     Live--; 
     DeadX = 900;
     DeadY = random(600);
     ImpactMusic();
    }
    
    //Plane hit bonus object
    if(DistancePlaneBonus < 40){
     Score=Score +2;
     BonusX = 600;
     BonusY = random(600);
     bonusMusic();
    }
    

    //here we draw the score
    fill(255, 255, 255);
    text("Score :", 50, 30); 
    fill(255, 255, 255);
    text( Score, 100, 30); 
    //here we draw the live
    text("Live :", 50, 60); 
    fill(255, 255, 255);
    text( Live, 100, 60); 
    
    //win game conditon
    if(Score==50){
     mode=-1;
    }
    
    if(Live==0){
      mode=-2; 
    }


   // Angle = mouseY-300; 
    //uncomment this line and comment the next one if you want to play with the mouse
    Angle = (18- DistanceUltra)*4;  // you can increase the 4 value...



    Hauteur = Hauteur + sin(radians(Angle))*10; //calculates the vertical position of the plane

    //check the height range to keep the plane on the screen 
    if (Hauteur < 0) {
        Hauteur=0;
    }

    if (Hauteur > 600) {
        Hauteur=600;
    }
    
    TraceAvion(Hauteur, Angle);

    ItemX = ItemX - cos(radians(Angle))*10;
    DeadX = DeadX - cos(radians(Angle))*15;
    BonusX = BonusX - cos(radians(Angle))*10;
    if (ItemX < -30) {
        ItemX=900;
        ItemY = random(600);
    }
    //move meteorite
    
     if (DeadX < -30) {
        DeadX =500;
        DeadY = random(300);
    }
    
    if(BonusX <-30){
     BonusX = 600;
     BonusY= random (400);
    }

    //draw and move the clouds
    for  (int i = 1; i <= 3; i = i+1) {
        CloudX[i] = CloudX[i] - cos(radians(Angle))*(10+2*i);

        image(Cloud, CloudX[i], CloudY[i], 200, 100);

        if (CloudX[i] < -300) {
            CloudX[i]=1000;
            CloudY[i] = random(400);
        }
    }
    image(Bonus, BonusX, BonusY,100,50);//display jerry
    image(Dead, DeadX, DeadY, 120, 60); //display meteorite
    image(Item, ItemX, ItemY, 59, 38); //displays item to collect. 59 and 38 are the size in pixels of the picture
    
}
}


void Ciel() {
    //draw the sky

    noStroke();
    rectMode(CORNERS);

    for  (int i = 1; i < 600; i = i+10) {
        fill( 49    +i*0.165, 118   +i*0.118, 181  + i*0.075   );
        rect(105, i, 105, i+10);
    }
}


void TraceAvion(float Y, float AngleInclinaison) {
    //draw the plane at given position and angle

    noStroke();
    pushMatrix();
    translate(400, Y);
    rotate(radians(AngleInclinaison)); //in degres  ! 


    /*
    Drawing concept :  ;-)
     */

    scale(0.5);  //0.2 pas mal

    // display the stored picture instead. 
    //Note that the parameters 2 and 3 are half the picture size,
    //to make sure that the plane rotates in his center.
    image(Plane, -111, -55, 250, 110); // 223 110 : picture size



    popMatrix(); //end of the rotation matrix
   //begin start screen music
 
  //begin game music
    if(startCounter==1){
  gameMusic();
}
 
}



//start screen

void startScreen()
{  
    
 startScreen=loadImage("startscreen.png");
 image(startScreen,-150,0);
 
 textAlign(CENTER);
 textSize(20);
 text("Press Space To Play",400,200); 
 fill(255, 69, 0);
 text("Hover your hand above the sensor to control the plane!",400,250); 
 fill(176, 224, 2300);  
  
}//end of startscreen

void winScreen()
{  
 startCounter=0;
 winScreen=loadImage("winscreen.jpg");
 image(winScreen,-300,-75);
 
 textAlign(CENTER);
 textSize(20);
 text("YOU WON!!",400,250); 
 fill(0, 0, 0);
 text("Press Space to play again.",400,470); 
 fill(0, 0, 0);
}//end of winScreen

void endScreen()
{  
 startCounter=0;
  endScreen=loadImage("endscreen.jpg");
  image(endScreen,-580,-250);
  textAlign(CENTER);
  textSize(20);
 /*text("GAME OVER =<",400,470); 
 fill(255, 255, 255); */
 
 text("Space to play again.",400,320); 
 fill(0,0,0);
}//end of endScreen



void startScreenMusic(){
  path= sketchPath(startAudio);
  file= new SoundFile(this,path);
  file.loop();
}

void startWinMusic(){
  file.stop();
  path= sketchPath(winMusic);
  file= new SoundFile(this,path);
  file.play();
}

void endScreenMusic(){
          file.stop();
          endPath= sketchPath(endMusic);
          endSound= new SoundFile(this,endPath);
          endSound.play(); 
}

void pickMusic(){
          pickPath= sketchPath(pickSound);
          pSound= new SoundFile(this,pickPath);
          pSound.play(); 
}

void ImpactMusic(){
          impactPath= sketchPath(impactMusic);
          impactSound= new SoundFile(this,impactPath);
          impactSound.play(); 
}

void bonusMusic(){
          bonusPath= sketchPath(bonusMusic);
          bonusSound= new SoundFile(this,bonusPath);
          bonusSound.play(); 
}

//game music

void gameMusic(){
  file.stop();
  path= sketchPath(audio);
  file= new SoundFile(this,path);
  file.loop();
}

//to start game
void keyPressed(){
 if(key ==' ')
   mode=1;
}

//to shoot
void mousePressed(){
 fire=true; 
}

void ballFalling(){
 stroke(39, 154, 240);
 fill (39,154,240);
 
 for (int i=0;i<5;i++){
  ellipse(ballX[i]++, ballY[i], ballSize, ballSize);
 }
}

  void cannon(int shotX)
  {
    boolean strike = false;
    for (int i = 0; i < 5; i++)
    {
      if((shotX >= (ballY[i]-ballSize/2)) && (shotX <= (ballY[i]+ballSize/2))) {
        strike = true;
        line( 565,mouseY, 0, mouseY);
        ellipse(ballX[i], ballY[i],
                ballSize+25, ballSize+25);
        ballX[i] = getRandomX();
        ballY[i] = 0;
        
      }    
    }
  
    if(strike == false)
    {
      line(565,mouseY, 0, mouseY);
    }  
  
  }
  
//file end